/*
  File autogenerated by gengetopt version 2.1  
  generated with the following command:
  gengetopt -ipswitch.ggo 

  The developers of gengetopt consider the fixed text that goes in all
  gengetopt output files to be in the public domain:
  we make no copyright claims on it.
*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
/* Check for configure's getopt check result.  */
#ifndef HAVE_GETOPT_LONG
#include "getopt.h"
#else
#include <getopt.h>
#endif

#include "cmdline.h"

/* Don't define PACKAGE and VERSION if we use automake.  */
#define PACKAGE "pswitch"
#define VERSION "0.01"


void
print_version (void)
{
  printf ("%s %s\n", PACKAGE, VERSION);
}

void
print_help (void)
{
  print_version ();
  printf ("Usage: %s [OPTIONS]...\n\
   -h         --help            Print help and exit\n\
   -V         --version         Print version and exit\n\
   -pSTRING   --port=STRING     Name of serial port\n\
   -c         --cts             React to CTS (default=off)\n\
   -d         --dsr             React to DSR (default=off)\n\
   -eSTRING   --execute=STRING  Command to execute\n\
   -v         --verbose         Verbose flag (default=off)\n\
   -q         --quiet           Quiet flag (default=off)\n\
", PACKAGE);
}


char *
gengetopt_strdup (char * s)
{
  char * n, * pn, * ps = s;
  while (*ps) ps++;
  n = (char *) malloc (1 + ps - s);
  if (n != NULL)
    {
      for (ps=s,pn=n; *ps; ps++,pn++)
        *pn = *ps;
      *pn = 0;
    }
  return n;
}


int
cmdline_parser (int argc, char **argv, struct gengetopt_args_info *args_info)
{
  int c;	/* Character of the parsed option.  */
  int missing_required_options = 0;	

  args_info->help_given = 0 ;
  args_info->version_given = 0 ;
  args_info->port_given = 0 ;
  args_info->cts_given = 0 ;
  args_info->dsr_given = 0 ;
  args_info->execute_given = 0 ;
  args_info->verbose_given = 0 ;
  args_info->quiet_given = 0 ;

#define clear_args()
{ \
  args_info->port_arg = NULL; \
  args_info->cts_flag = 0;\
  args_info->dsr_flag = 0;\
  args_info->execute_arg = NULL; \
  args_info->verbose_flag = 0;\
  args_info->quiet_flag = 0;\
}

  clear_args();

  while (1)
    {
      int option_index = 0;
      static struct option long_options[] = {
        { "help",	0, NULL, 'h' },
        { "version",	0, NULL, 'V' },
        { "port",	1, NULL, 'p' },
        { "cts",	0, NULL, 'c' },
        { "dsr",	0, NULL, 'd' },
        { "execute",	1, NULL, 'e' },
        { "verbose",	0, NULL, 'v' },
        { "quiet",	0, NULL, 'q' },
        { NULL,	0, NULL, 0 }
      };

      c = getopt_long (argc, argv, "hVp:cde:vq", long_options, &option_index);

      if (c == -1) break;	/* Exit from `while (1)' loop.  */

      switch (c)
        {
        case 'h':	/* Print help and exit.  */
          clear_args ();
          print_help ();
          exit (0);

        case 'V':	/* Print version and exit.  */
          clear_args ();
          print_version ();
          exit (0);

        case 'p':	/* Name of serial port.  */
          if (args_info->port_given)
            {
              fprintf (stderr, "%s: `--port' (`-p') option given more than once\n", PACKAGE);
              clear_args ();
              print_help ();
              exit (1);
            }
          args_info->port_given = 1;
          args_info->port_arg = gengetopt_strdup (optarg);
          break;

        case 'c':	/* React to CTS.  */
          args_info->cts_flag = !(args_info->cts_flag);
          break;

        case 'd':	/* React to DSR.  */
          args_info->dsr_flag = !(args_info->dsr_flag);
          break;

        case 'e':	/* Command to execute.  */
          if (args_info->execute_given)
            {
              fprintf (stderr, "%s: `--execute' (`-e') option given more than once\n", PACKAGE);
              clear_args ();
              print_help ();
              exit (1);
            }
          args_info->execute_given = 1;
          args_info->execute_arg = gengetopt_strdup (optarg);
          break;

        case 'v':	/* Verbose flag.  */
          args_info->verbose_flag = !(args_info->verbose_flag);
          break;

        case 'q':	/* Quiet flag.  */
          args_info->quiet_flag = !(args_info->quiet_flag);
          break;

        case '?':	/* Invalid option.  */
          /* `getopt_long' already printed an error message.  */
          exit (1);

        default:	/* bug: option not considered.  */
          fprintf (stderr, "%s: option unknown: %c\n", PACKAGE, c);
          abort ();
        } /* switch */
    } /* while */

  if (! args_info->port_given)
    {
      fprintf (stderr, "%s: `--port' (`-p') option required!\n", PACKAGE);
      missing_required_options = 1;
    }

  if ( missing_required_options )
    exit (1);


  return 0;
}